#include <bits/stdc++.h>
using namespace std;
int main()
{
    int n,m,x;
    cin>>n;
    int bp[n][9]={},bn[n][9]={};
    bool dali[n];
    for(int i=0;i<n;i++){
        cin>>m;
        for(int j=0;j<m;j++){
            cin>>x;
            if(x!=0){
                if(x>0){
                    if(j%2==0){
                        bp[i][x-1]+=1;
                    }
                    else{
                        bn[i][x-1]+=1;
                    }
                }
                else if(x<0){
                    if(j%2==0){
                        bn[i][x-1]+=1;
                    }
                    else{
                        bp[i][x-1]+=1;
                    }
                }
            }
        }
    }
    for(int i=0;i<n;i++){
        dali[i]=true;
        for(int j=0;j<9;j++){
            if(bp[i][j]!=bn[i][j]){
                dali[i]=false;
            }
        }
        if(dali[i]==true)
            cout<<"DA"<<endl;
        else
            cout<<"NE"<<endl;
    }
}